searchNodes=[{"doc":"A leftiest tree/heap implemtation with customizable priority and any type of item. This tree always enforces the smallest priority at the top node, and the left path of tree is higher than right. See https://en.wikipedia.org/wiki/Leftist_tree for algorithm details.","ref":"Heap.LeftiestTree.html","title":"Heap.LeftiestTree","type":"module"},{"doc":"Returns true if the leftest tree is empty. NOTE: the nil is an empty leftest tree also. Examples iex&gt; Heap.LeftiestTree . single ( 1 ) ...&gt; |&gt; Heap.LeftiestTree . empty? false","ref":"Heap.LeftiestTree.html#empty?/1","title":"Heap.LeftiestTree.empty?/1","type":"function"},{"doc":"Merges two leftiest trees into a leftiest tree. Examples iex&gt; nil ...&gt; |&gt; Heap.LeftiestTree . merge ( Heap.LeftiestTree . single ( 1 ) ) ...&gt; |&gt; Heap.LeftiestTree . merge ( nil ) ...&gt; |&gt; Heap.LeftiestTree . merge ( Heap.LeftiestTree . single ( - 1 ) ) ...&gt; |&gt; Heap.LeftiestTree . to_list [ %{ item : 1 , priority : 1 } , %{ item : - 1 , priority : - 1 } ]","ref":"Heap.LeftiestTree.html#merge/2","title":"Heap.LeftiestTree.merge/2","type":"function"},{"doc":"Removes the topest node of tree, rebalances the tree, and returns. Do nothing if tree is empty. Examples iex&gt; Heap.LeftiestTree . single ( 1 ) ...&gt; |&gt; Heap.LeftiestTree . pop ...&gt; |&gt; Heap.LeftiestTree . empty? true iex&gt; Heap.LeftiestTree . single ( 1 ) ...&gt; |&gt; Heap.LeftiestTree . pop ...&gt; |&gt; Heap.LeftiestTree . pop nil","ref":"Heap.LeftiestTree.html#pop/1","title":"Heap.LeftiestTree.pop/1","type":"function"},{"doc":"Returns a single node leftest tree, with item and use this item as priority. Examples iex&gt; Heap.LeftiestTree . single ( 1 ) ...&gt; |&gt; Heap.LeftiestTree . size 1","ref":"Heap.LeftiestTree.html#single/1","title":"Heap.LeftiestTree.single/1","type":"function"},{"doc":"Returns a single node leftiest tree, with item and priority. Examples iex&gt; Heap.LeftiestTree . single ( 1 , 1 ) ...&gt; |&gt; Heap.LeftiestTree . size 1","ref":"Heap.LeftiestTree.html#single/2","title":"Heap.LeftiestTree.single/2","type":"function"},{"doc":"Returns the number of elements in tree. Examples iex&gt; nil |&gt; Heap.LeftiestTree . size 0 iex&gt; Heap.LeftiestTree . single ( 1 ) |&gt; Heap.LeftiestTree . size 1","ref":"Heap.LeftiestTree.html#size/1","title":"Heap.LeftiestTree.size/1","type":"function"},{"doc":"Returns the list of %{priority: ..., item:, ...} ordered by priority descendingly. Examples iex&gt; Heap.LeftiestTree . single ( - 10 ) ...&gt; |&gt; Heap.LeftiestTree . merge ( Heap.LeftiestTree . single ( 1 ) ) ...&gt; |&gt; Heap.LeftiestTree . merge ( Heap.LeftiestTree . single ( 3 ) ) ...&gt; |&gt; Heap.LeftiestTree . merge ( Heap.LeftiestTree . single ( - 1 ) ) ...&gt; |&gt; Heap.LeftiestTree . to_list [ %{ item : 3 , priority : 3 } , %{ item : 1 , priority : 1 } , %{ item : - 1 , priority : - 1 } , %{ item : - 10 , priority : - 10 } ]","ref":"Heap.LeftiestTree.html#to_list/1","title":"Heap.LeftiestTree.to_list/1","type":"function"},{"doc":"Returns the top node of tree. If the tree is empty, returns {:error, &quot;empty tree&quot;}, otherwise returns {:ok, %{priority: ..., item: ...}} Examples iex&gt; Heap.LeftiestTree . single ( 1 ) ...&gt; |&gt; Heap.LeftiestTree . top { :ok , %{ priority : 1 , item : 1 } } iex&gt; Heap.LeftiestTree . single ( 1 ) ...&gt; |&gt; Heap.LeftiestTree . pop ...&gt; |&gt; Heap.LeftiestTree . top { :error , &quot;empty tree&quot; }","ref":"Heap.LeftiestTree.html#top/1","title":"Heap.LeftiestTree.top/1","type":"function"},{"doc":"A proirity queue implemetation. The priority of each elements can be customized when enqueue .","ref":"Heap.PQ.html","title":"Heap.PQ","type":"module"},{"doc":"Dequeue and pick the smallest priority item. If everything is ok, it returns {:ok, new_queue, picked_item}, otherwise it returns {:error, reason}. Examples iex&gt; { :ok , _ , item } = Heap.PQ . empty ( ) |&gt; Heap.PQ . enqueue ( 1 , - 1 ) |&gt; Heap.PQ . enqueue ( 3 , - 3 ) |&gt; Heap.PQ . enqueue ( - 3 , 3 ) |&gt; Heap.PQ . dequeue ( ) iex&gt; item 3","ref":"Heap.PQ.html#dequeue/1","title":"Heap.PQ.dequeue/1","type":"function"},{"doc":"Returns an empty priority queue. Examples iex&gt; Heap.PQ . empty ( ) |&gt; Heap.PQ . empty? ( ) true","ref":"Heap.PQ.html#empty/0","title":"Heap.PQ.empty/0","type":"function"},{"doc":"Returns whether the queue is empty.","ref":"Heap.PQ.html#empty?/1","title":"Heap.PQ.empty?/1","type":"function"},{"doc":"Enqueue an item into queue with optional priority. If priority is not set, the item itself is considered as the priority. Returns a new queue with item enqueued. Examples iex&gt; { :ok , _ , item } = Heap.PQ . empty ( ) |&gt; Heap.PQ . enqueue ( 1 , - 1 ) |&gt; Heap.PQ . enqueue ( 3 , - 3 ) |&gt; Heap.PQ . enqueue ( - 3 , 3 ) |&gt; Heap.PQ . dequeue ( ) iex&gt; item 3","ref":"Heap.PQ.html#enqueue/3","title":"Heap.PQ.enqueue/3","type":"function"}]